<?php
namespace app\index\controller\Index;
use app\common\controller\_Index;
use x\Elasticsearch;

class index extends _Index{

    public function run($param=[]) {
        // 先载入配置
        \x\elasticsearch\tool\Client::start();
        // 挂载嗅探
        \x\elasticsearch\tool\Client::normal_sniff_interval();
        \x\elasticsearch\tool\Client::fault_sniff_interval();
        // 获得一个节点
        $node = \x\elasticsearch\tool\Client::get_node();

        // ES组件
        $Elasticsearch = new Elasticsearch();

        // 删除索引表
        $res = $Elasticsearch->table('shop')->deleteTable();dump($res);
        // 创建索引
        $settings =  [
            'number_of_shards' => 5, // 分片值5
            'number_of_replicas' => 0 // 分布式拷贝数量为0
        ];
        $field = [
            'title' => [
                'type' => 'text',
            ],
            'age' => [
                'type' => 'range',
            ],
        ];
        $res = $Elasticsearch->table('shop')->createTable($settings, $field);dump($res);
        // 修改字段
        $res = $Elasticsearch->table('shop')->updateField($field);dump($res);
        // 设置索引表别名
        $res = $Elasticsearch->table('shop')->aliasTable('db_shop');dump($res);
        // 读取索引表详情
        $res = $Elasticsearch->table('shop')->getTable();dump($res);
        // 插入数据
        $res = $Elasticsearch->table('shop')->id(1)->insert([
            'title' => '我的天啊', 'age' => 25
        ]);dump($res);
        // 修改数据
        $res = $Elasticsearch->table('shop')->id(1)->update([
            'title' => '测试I', 'age' => 25
        ]);dump($res);
        // 读取一条数据
        $res = $Elasticsearch->table('shop')->id(1)->get();dump($res);
        // 读取指定记录，某个字段的值
        $res = $Elasticsearch->table('shop')->id(1)->value('title');dump($res);
        // 按主键删除数据
        $res = $Elasticsearch->table('shop')->id(1)->delete();dump($res);
        // 批量插入数据
        $res = $Elasticsearch->table('shop')->insertAll([
            ['title' => '克利夫兰骑士队1', 'age' => 18],
            ['title' => '克利夫兰骑士队2', 'age' => 25],
            ['title' => '克利夫兰骑士队3', 'age' => 35],
        ], 3);dump($res);

        // 查询数据
        $where = [
            ['title', '=', '骑士队', 'must'],
            ['title', '=', '利夫兰', 'filter'],
            ['age', '>=', 18],
            ['age', '<=', 28],
            // ['title', 'terms', ['测试', 'H']]
        ];
        $res = $Elasticsearch->table('shop')->where($where)->order('age DESC')->field('title')->page(1, 10)->select();dump($res);
        // 按条件删除数据
        $res = $Elasticsearch->table('shop')->where($where)->delete();dump($res);

        // 聚合查询
        $res = $Elasticsearch->table('shop')->where($where)->count();dump($res);
        $res = $Elasticsearch->table('shop')->where($where)->max('age')->min('age')->avg('age')->sum('age')->aggs();dump($res);

        // 执行原生查询
        $res = $Elasticsearch->exec('/shop/_search', \x\elasticsearch\tool\Client::GET, []);dump($res);
    }
    
}
